/* KMB 2003 Oct 19
   gcc test-covariance.c -o test-covariance -lm
   mcopy -o test-covariance.c a:

octave:1> s=[1,-0.2,0.1;-0.2,2,0.5;0.1,0.5,5]
   1.00000  -0.20000   0.10000
  -0.20000   2.00000   0.50000
   0.10000   0.50000   5.00000
octave:2> chol(s)
   1.00000  -0.20000   0.10000
   0.00000   1.40000   0.37143
   0.00000   0.00000   2.20273
*/

#include "rng-kmb.c"

void multinormal(double y[3], double L[3][3]) {
  int i,j;
  double s,x[3];
  for (i=0; i<3; i++) x[i]=normal01();
  for (i=0; i<3; i++) {
    s=0.0;
    for (j=0; j<i+1; j++) s+=L[i][j]*x[j];
    y[i]=s;
  }
  return;
}

int main(int argc, char* argv[]) {
  int i,n=100000;
  double L[3][3],y[3];
  L[0][0]= 1.00000; L[0][1]=-0.20000; L[0][2]=0.10000;
  L[1][0]=-0.20000; L[1][1]= 1.40000; L[1][2]=0.37143;
  L[2][0]= 0.10000; L[2][1]= 0.37143; L[2][2]=2.20273;
  if (argc>1) n=atoi(argv[1]);
  for (i=0; i<n; i++) {
    multinormal(y,L);
    printf("%g %g %g\n",y[0],y[1],y[2]);
  }
  return 0;
}
